#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netdb.h>
#include <string.h>
#include <stdarg.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <errno.h>
#include <pthread.h>

int MAX_THREADS=2;

#define BUFFER_SIZE 8192
#define BUFFER_SIZE_LINE 1024
//#define BUFFER_SIZE 500
#define BUFFER_DOWNLOAD_SIZE 8192

#define DEFAULT_DOWNLOAD_FOLDER "./dl/"
#define DEFAULT_RESUME 'Y'

#define ROLLBACK (10*1024)

#define FTP_PASSIVE_MODE 1
#define FTP_NORMAL_MODE 2

#define ERR_URL_PROTO_UNKNOWN 1
#define ERR_URL_SYNTAX_ERROR 2
#define ERR_CANT_RESOLVE 3
#define ERR_CANT_CONNECT 4
#define ERR_SOCKET_SELECT 5
#define ERR_SOCKET_TIMEOUT 6
#define ERR_SOCKET_WRITE_ERROR 7

#define ERR_FTP_SERVER_UNKNOWN_ANSWER 8
#define ERR_FTP_SERVER_PERMISSION_DENIED 550


#define ERR_FILE_NOT_FOUND 9
#define ERR_MALLOC_ERROR 10
#define ERR_FILE_ERROR 11

#define PROTO_FTP 1
#define PROTO_HTTP 2

#define FTP_DEFAULT_PORT 21
#define FTP_DEFAULT_MODE FTP_PASSIVE_MODE
#define HTTP_DEFAULT_PORT 80

#include "listes.h"

//_infos infos[MAX_FILES];


char *nextspace(char *);
char *nextspace_r(char *, char *);
char *nextchar(char *);
char *nextchar_r(char *, char *);
void parse_line(_infos *,char *);
int ecrit(int,const char *,...);
int get_line_once(int, char *, char *, int *);
int saveList(_infos *);
int download(_infos *);


/* Parse l'url et remplit la structure */
int init_infos(_infos * infos, char *url){
	//char *url=infos->url;
	char *tmp;
	char *deuxpoints;
	char *at;
	char *firstslash;
	char *lastslash;

	/* Regarde si le protocole est OK */
	if(strncasecmp(url,"ftp://",6)==0){
		infos->hostinfos->proto=PROTO_FTP;
		infos->hostinfos->ftp_mode=FTP_DEFAULT_MODE;
	} else if(strncasecmp(url,"aftp://",7)==0){
		infos->hostinfos->proto=PROTO_FTP;
		infos->hostinfos->ftp_mode=FTP_NORMAL_MODE;
	} else if(strncasecmp(url,"pftp://",7)==0){
		infos->hostinfos->proto=PROTO_FTP;
		infos->hostinfos->ftp_mode=FTP_PASSIVE_MODE;
	} else if(strncasecmp(url,"http://",7)==0){
		infos->hostinfos->proto=PROTO_HTTP;
	}
	else{
		if(strstr(url,"://")){
			return ERR_URL_PROTO_UNKNOWN;
		}
		/* FTP par defaut */
		tmp=strdup(url);
		sprintf(url,"ftp://%s",tmp);	/* FIXME ! attention au buffer overflow! */
		free(tmp);
		infos->hostinfos->proto=PROTO_FTP;
		infos->hostinfos->ftp_mode=FTP_DEFAULT_MODE;
	}

	/* enleve le 'xxx://' du debut de l'url */
	tmp=strdup(url);
	sprintf(url,"%s",strstr(url,"://")+3);
	free(tmp);



	/* Choppe un eventuel user et pass */
	/* FIXME! on a vraiment besoin d'une variable temporaire? */
	if( at=index(url,'@') ){
		tmp=strdup(url);
		tmp[strlen(tmp)-strlen(at)]='\0';
		/* tmp contient maintenant: 'user:pass' */

		if( (deuxpoints=index(tmp,':'))==NULL ){
			free(tmp);
			return ERR_URL_SYNTAX_ERROR;
		}

		/* enleve le 'user:pass' du debut de l'url */
		memmove(url,url+strlen(tmp)+1,strlen(url)-strlen(tmp));

		strcpy(infos->hostinfos->pass,deuxpoints+1);
		*deuxpoints='\0';
		strcpy(infos->hostinfos->user,tmp);
		free(tmp);
	}
	else{
		strcpy(infos->hostinfos->user,"anonymous");
		strcpy(infos->hostinfos->pass,"billg@hotmail.com");
	}



	/* Recupere le port le cas echeant */
	firstslash=index(url,'/');
	if(firstslash==NULL) firstslash=url+strlen(url);
	tmp=strdup(url);


	tmp[strlen(url)-strlen(firstslash)]='\0';
	if( deuxpoints=index(tmp,':') ){
		infos->hostinfos->port=atoi(deuxpoints+1);
		*deuxpoints='\0';
		sprintf(url,"%s%s",tmp,firstslash); /* FIXME buffer overflow? */
	}
	else {
		if(infos->hostinfos->proto==PROTO_FTP) infos->hostinfos->port=FTP_DEFAULT_PORT;
		if(infos->hostinfos->proto==PROTO_HTTP) infos->hostinfos->port=HTTP_DEFAULT_PORT;
	}
	free(tmp);


	if(infos->hostinfos->port==0) return ERR_URL_SYNTAX_ERROR;




	/* Si l'URL se termine par un slash, on l'enleve */
	//if(url[strlen(url)-1]=='/') url[strlen(url)-1]='\0';

	/* on separe l'ip et le path */
	tmp=strdup(url);
	firstslash=index(tmp,'/');
	if(firstslash==NULL) firstslash=tmp+strlen(tmp);
	strcpy(infos->path,firstslash);

	*firstslash='\0';
	strcpy(infos->hostinfos->hostname,tmp);
	free(tmp);

	/* On recupere l'ip */
	if(getip(infos->hostinfos->hostname,infos->hostinfos->ip)) return ERR_CANT_RESOLVE;

	if(infos->isafolder!='N' && infos->isafolder!='Y') infos->isafolder='?';

	/* On separe le path et le nom de fichier */

	tmp=strdup(infos->path);
	lastslash=rindex(infos->path,'/');
	if(lastslash==NULL) lastslash=infos->path+strlen(infos->path);

	if( strlen(infos->path)>0 && lastslash==infos->path+strlen(infos->path)-1 ){
		/* Si le path se termine par un slash */
		infos->isafolder='Y';
		infos->filename[0]='\0';
	}
	*lastslash='\0';

	strcpy(infos->filename,1+tmp+strlen(infos->path));
	free(tmp);

	if(strcmp(infos->path,"")==0) strcpy(infos->path,"/");

	defaultvalues(infos);

	if(strcmp(infos->path,"/")==0 && strcmp(infos->filename,"")==0 ){
		// Root directory
		infos->isafolder='Y';
	}

	return 0;
}


int connexion(_infos * infos){
	int retcode;
	struct sockaddr_in sockaddr;
	int sockaddr_length;

	infos->sockfd=socket(AF_INET,SOCK_STREAM,0);
	if(infos->sockfd==-1) return ERR_SOCKET_WRITE_ERROR;
	sockaddr.sin_family=AF_INET;
	sockaddr.sin_addr.s_addr=inet_addr(infos->hostinfos->ip);
	sockaddr.sin_port=htons(infos->hostinfos->port);
	sockaddr_length=sizeof(sockaddr);

	if( retcode=connect(infos->sockfd, (struct sockaddr*)&sockaddr, sockaddr_length) ) return ERR_CANT_CONNECT;
	if( retcode=wait4(infos->sockfd,220) ) return retcode;
	if( retcode=ecrit(infos->sockfd,"USER %s\r\n",infos->hostinfos->user) ) return retcode;

	if( retcode=wait4(infos->sockfd,331) ) return retcode;

	if( retcode=ecrit(infos->sockfd,"PASS %s\r\n",infos->hostinfos->pass) ) return retcode;
	if( retcode=wait4(infos->sockfd,230) ) return retcode;

	//if( retcode=ecrit(infos->sockfd,"CWD /\r\n") ) return retcode;
	//if( retcode=wait4(infos->sockfd,250) ) return retcode;

	if( retcode=ecrit(infos->sockfd,"TYPE I\r\n") ) return retcode;
	if( retcode=wait4(infos->sockfd,200) ) return retcode;



	return 0;
}

int send_cwd(_infos *infos){
	int retcode;

	if( retcode=ecrit(infos->sockfd,"CWD %s\r\n",infos->path) ) return retcode;
	if( retcode=wait4(infos->sockfd,250) ){
		switch(retcode){
			case ERR_FTP_SERVER_PERMISSION_DENIED:
				// FIXME: bah on fait rien...
				infos->isafolder='E';
				break;
			default:
				return retcode;
		}
	}

	return retcode;
}


int send_pasv(_infos *infos){
	char buffer[BUFFER_SIZE];
	int sockfd=infos->sockfd;
	int resultat;
	char line[BUFFER_SIZE_LINE];
	char buffer2[4];
	int offset;


	if(infos->hostinfos->ftp_mode==FTP_PASSIVE_MODE){
		if( resultat=ecrit(sockfd,"PASV\r\n") ) return resultat;


		offset=0;
		buffer[0]='\0';

		if(resultat=get_line_once(sockfd, buffer, line, &offset)) return resultat;	
		printf("Recu: %s\n",line);
		strncpy(buffer2,line,3);
		buffer2[3]='\0';
		resultat=atoi(buffer2);


		{
			int i;
			int p1,p2;
			char *deb;
			deb=rindex(line,'(')+1;

					*index(deb,')')='\0';

			for(i=0;i<4;i++) deb=index(deb,',')+1;

			p2=atoi(index(deb,',')+1);
			*index(deb,',')='\0';
			p1=atoi(deb);

			infos->dataport=256*p1+p2;

		}
		//free(line);

		if(connect_data_socket(infos)) return ERR_CANT_CONNECT;
	}

	else{} /* FIXME: PORT */


	return 0;
}


int connect_data_socket(_infos * infos){
	int retcode;
	struct sockaddr_in sockaddr;
	int sockaddr_length;

	infos->sockfd_data=socket(AF_INET,SOCK_STREAM,0);
	if(infos->sockfd_data==-1) return ERR_SOCKET_WRITE_ERROR;
	sockaddr.sin_family=AF_INET;
	sockaddr.sin_addr.s_addr=inet_addr(infos->hostinfos->ip);
	sockaddr.sin_port=htons(infos->dataport);
	sockaddr_length=sizeof(sockaddr);
	if( retcode=connect(infos->sockfd_data, (struct sockaddr*)&sockaddr, sockaddr_length) ) return ERR_CANT_CONNECT;
	return 0;
}

int main(){
	_infos *ptr;
	_infos *ptr_bak;
	_infos *infos;
	_infos *suiv;
	int sockfd=-1;
	int sockfd_data=-1;

	char url[8192];

	void *res;
	//pthread_t t1;
	//pthread_t t2;


	int i=0;

	int retcode;

	if( (liste_deb=liste_clone_after(NULL))==NULL) return ERR_MALLOC_ERROR;
	liste_deb->hostinfos=(_hostinfos *)malloc(sizeof(_hostinfos)); 
	if(liste_deb->hostinfos==NULL){ 
		free(ptr); 
		return ERR_MALLOC_ERROR; 
	}								


	infos=liste_deb;

	strcpy(url,"ftp://pftp:access@192.168.1.2");
	//strcpy(url,"ftp://pftp:access@192.168.2.2/zik/Pi Soundtrack/12_Spacetime_Continuum_-_A_Low_Frequency_Inversion_Field.mp3");
	//strcpy(url,"ftp://cyberic:accf82bt@ftpperso.free.fr");
	//strcpy(url,"ftp://eric:fqzuabmx@grenades.dyndns.org");
	//strcpy(url,"ftp://pftp:access@192.168.1.2/mariokart.smc");
	//strcpy(url,"ftp://pftp:access@192.168.1.2/zik");
	//strcpy(url,"ftp://pftp:access@192.168.1.2");
	//strcpy(url,"ftp://sven:dev2113@ftp.nunux.net/datas/ftp/site/FR/MP3/");

	/* on sort si l'url n'est pas valide */
	if( retcode=init_infos(liste_deb, url) ) return retcode;

	if( retcode=connexion(liste_deb) ){
		printf("Erreur: Code d'erreur: %i\n",retcode);
		perror("err: \n");
		return -1;
	}


	for(i=0;i<5;i++){

		ptr=liste_deb;
		while(ptr!=NULL){
			//affiche_infos(ptr);
			suiv=ptr->suiv;
			if(ptr->isafolder=='Y'){
				if(ptr->sockfd==-1){
					ptr->sockfd=sockfd;
					ptr->sockfd_data=sockfd_data;
					printf("load: %i %i\n",ptr->sockfd,ptr->sockfd_data);

				}
				else{
					printf("save: %i %i\n",ptr->sockfd,ptr->sockfd_data);
					sockfd=ptr->sockfd;
					sockfd_data=ptr->sockfd_data;
				}
				printf("dossier: %s/%s\n",ptr->path,ptr->filename);

				if(retcode=getinfos_folder(ptr)) {
					printf("rretcode: %i\n",retcode);
					return retcode;    
				}
				printf("fin dossier\n");
				liste_deb=liste_del(ptr);
				//printf("del\n");
				//affiche_infos(liste_deb);
				ptr=liste_deb;

			}
			else{
				ptr=suiv;
			}
		}
	}


	printf("-----------------------\n");
	affiche_infos(liste_deb);
	printf("-----------------------\n");


	CloseSockets(liste_deb);




	ptr=liste_prec(liste_last(liste_deb));

	///////
	for(i=1;i<3;i++){
		ptr=liste_prec(ptr);
		retcode=pthread_create(&ptr->threadID,0,(void *)download,(void*)ptr);
	}


	//retcode=pthread_create(&t2,0,(void *)download,(void*)liste_prec(liste_prec(liste_last(liste_deb))));

	printf("errrrr %i\n",retcode);
	printf("on dort %i\n",sizeof(_infos));
	//sleep(5);
	ptr=liste_deb;
	while(ptr!=NULL){
		if(ptr->threadID!=0){
			printf("join: %i\n",pthread_join(ptr->threadID,&res));
		}
		ptr=ptr->suiv;
	}

	//close(liste_deb->sockfd);
	//close(liste_deb->sockfd_data);

	if(retcode=saveList(liste_deb)) return retcode;

	//liste_del_all(liste_deb);
	//if(retcode=loadList(liste_deb)) return retcode;
	//affiche_infos(liste_deb);	

}

int CloseSockets(_infos *infos){
	if(infos->sockfd_data!=-1){
		CloseDataSocket(infos);
	}
	if(infos->sockfd!=-1){
		ecrit(infos->sockfd,"QUIT\r\n");
		wait4(infos->sockfd,221);
		shutdown(infos->sockfd,2);
		infos->sockfd=-1;
	}
}

int CloseDataSocket(_infos *infos){
	shutdown(infos->sockfd_data,2);
	infos->sockfd_data=-1;
}

int loadList(_infos *ptr){
	char buffer[BUFFER_SIZE];
	FILE *fp=fopen("./queue.txt","r");
	char *mot;
	int retcode;
	int completedSize, size;
	char isafolder;
	_infos *newList;

	//char url[8192];
	liste_deb=NULL;



	while(!feof(fp)){
		fgets(buffer,BUFFER_SIZE,fp);
		if(feof(fp)) break;

		buffer[strlen(buffer)-1]='\0';
		//printf("buff: %s\n",buffer);
		mot=buffer+strlen(buffer);
		mot=nextchar_r(buffer,mot);
		mot=nextspace_r(buffer,mot);
		if(strlen(mot)>1 && mot[strlen(mot)-1]=='\"'){ // Si le path est marque
			mot=mot+strlen(mot)-2;
			if(mot<buffer) mot=buffer;
			while(mot>buffer+1 && *mot!='\"') mot--;
			//printf("m:%s-\n",mot);


			// FIXME: parser le path par defaut entre double-quotes
			//printf("path: %s\n",mot);

			if(mot-1>buffer) mot--;
			*mot='\0';
			mot=nextspace_r(buffer,mot);

		}
		mot=nextchar(mot);

		//premier mot
		isafolder='?';
		if(strcmp(mot,"folder")==0){
			//printf("folder\n");
			completedSize=0;
			size=0;
			isafolder='Y';
		}
		else{
			//printf("1 mot: -%s-\n",mot);
			sscanf(mot,"%i/%i",&completedSize,&size);
			//printf("%i %i\n",completedSize, size);
			isafolder='N';

		}

		mot=nextspace_r(buffer, mot);
		*mot='\0';

		mot=buffer;
		//printf("2 mot: -%s-\n",mot);

		newList=liste_clone_after(liste_last(liste_deb));
		if(liste_deb==NULL) liste_deb=newList;


		//strcpy(url,mot);
		newList->completedSize=completedSize;
		newList->size=size;
		newList->isafolder=isafolder;

		if( retcode=init_infos(newList, mot) ) return retcode;

		if(strcmp(newList->path,"/")!=0){
			if(newList->isafolder=='Y'){
				// FIXME: pas tres propre...
				strcat(newList->path,"/");
				strcat(newList->path,newList->filename);
				strcpy(newList->filename,"");
			} else if(newList->isafolder=='N'){
				strcat(newList->path,"/");
			}
		}
	}

	fclose(fp);

	return 0;
}

int saveList(_infos *ptr){
	char buffer[BUFFER_SIZE];
	char buffer2[BUFFER_SIZE];

	FILE *fp=fopen("./queue.txt","w");
	if(fp==NULL) return ERR_FILE_ERROR;

	for(;ptr!=NULL;ptr=ptr->suiv){

		buffer[0]='\0';
		buffer2[0]='\0';
		if(rindex("?YN",ptr->isafolder)==NULL) continue;

		if(ptr->hostinfos->proto==PROTO_HTTP){
			strcat(buffer,"http://");
		}
		else if(ptr->hostinfos->proto==PROTO_FTP && ptr->hostinfos->ftp_mode==FTP_PASSIVE_MODE){
			strcat(buffer,"ftp://");
		}
		else if(ptr->hostinfos->proto==PROTO_FTP && ptr->hostinfos->ftp_mode==FTP_NORMAL_MODE){
			strcat(buffer,"aftp://");
		}
		else continue;


		if(ptr->hostinfos->user!="" && ptr->hostinfos->user!=""){
			sprintf(buffer2,"%s:%s@",ptr->hostinfos->user,ptr->hostinfos->pass);
			strcat(buffer,buffer2);
		}

		strcat(buffer,ptr->hostinfos->hostname);
		strcat(buffer,":");

		sprintf(buffer2,"%i",ptr->hostinfos->port);
		strcat(buffer,buffer2);

		strcat(buffer,ptr->path);
		if(ptr->filename[0]!='\0') strcat(buffer,ptr->filename);

		strcat(buffer," ");


		if(ptr->isafolder=='?'){
			strcpy(buffer2,"?");
		}
		else if(ptr->isafolder=='N'){
			buffer2[0]='\0';
			sprintf(buffer2,"%li/%li",ptr->completedSize,ptr->size);
		}
		else if(ptr->isafolder=='Y'){
			strcpy(buffer2,"folder");
		}
		strcat(buffer,buffer2);


		if(ptr->localFilePath[0]!='\0' && ptr->localFileName[0]!='\0'){
			sprintf(buffer2," \"%s%s\"",ptr->localFilePath,ptr->localFileName);
		}

		strcat(buffer,"\n");
		//printf("i: %s",buffer);
		fwrite(buffer,strlen(buffer),1,fp);
	}
	fclose(fp);
	return 0;
}


int download(_infos *infos){
	int size;
	int restartPos=0;
	char buffer[BUFFER_DOWNLOAD_SIZE+1];
	int retcode=0;
	int sizeLeft;
	FILE *fp=NULL;
	int nb=0;
	char localPathComplet[PATH_MAX];
	struct stat stats;
	int sizeToRead;
	int rollback=0;

	if(infos==NULL) return 0;
	if(infos->isafolder!='N') return 0;

	printf("connexion...\n");

	if( retcode=connexion(infos) ){
		printf("Erreur: Code d'erreur: %i\n",retcode);
		perror("erre: \n");
		return -1;
	}

	printf("dl de %s\n",infos->filename);


	size=infos->size;

	/* on trouve le nom du fichier, avec autorename_feature */

	strcpy(infos->localFileName,infos->filename);
	if(strcmp(infos->localFilePath,"")==0) strcpy(infos->localFilePath,DEFAULT_DOWNLOAD_FOLDER);

	//FIXME: revoir l'algo de renommage si le fichier existe deja, selon la taille, etc...


	snprintf(localPathComplet,PATH_MAX,"%s%s",infos->localFilePath,infos->localFileName); // FIXME ! strncat    

	retcode=stat(localPathComplet,&stats);
	if(retcode==0){  // Le fichier existe deja
		if( (int)stats.st_size == infos->size) return 0; // S'il est deja complet
		if(infos->completedSize==0){ // On doit utiliser l'"auto-rename feature"
			int nb=0;
			char *point;
			char localFileName[FILENAME_MAX];
			char localFileNameExt[FILENAME_MAX];
			strcpy(localFileName,infos->localFileName);
			strcpy(localFileNameExt,"");
			point=rindex(localFileName,'.');
			if(point!=NULL){
				strncpy(localFileNameExt,point,strlen(point));
				*point='\0';
			}
			for(;;){
				nb++;
				snprintf(localPathComplet,PATH_MAX,"%s%s_%i%s",infos->localFilePath,localFileName,nb,localFileNameExt); // FIXME ! strncat    
				//printf("essai: %s\n",localPathComplet);
				retcode=stat(localPathComplet,&stats);
				if(retcode==0 && (int)stats.st_size == infos->size) return 0; // S'il est deja complet
				else if(retcode==-1){
					retcode=0;
					snprintf(infos->localFileName,FILENAME_MAX,"%s%s_%i%s",infos->localFilePath,localFileName,nb,localFileNameExt); // FIXME ! strncat    
					break;
				}
			}		
		}
		else{ // Le fichier existe et n'est pas downloade jusqu'au bout
			if(DEFAULT_RESUME=='Y'){
				rollback=ROLLBACK;
				if(rollback>stats.st_size) rollback=stats.st_size;
			}
			else{ // On recommence au debut le telechargement
				rollback=stats.st_size;

			}
		}
	}
	else if(retcode==-1){  // Le fichier n'existe pas
		retcode=0;
	}

	if( (fp=fopen(localPathComplet,"a"))==NULL ) return ERR_FILE_ERROR;
	if(rollback){
		fseek(fp,-rollback,SEEK_CUR);
		restartPos=ftell(fp);
	}


	if(retcode) return retcode;

	printf("path: %s, filename %s\n",infos->localFilePath,infos->localFileName);

	if(retcode=send_pasv(infos)) return retcode;
	if(retcode=send_cwd(infos)) return retcode;

	printf("pp: %s\n",localPathComplet);
	if(retcode=ecrit(infos->sockfd,"REST 100\r\n")) {fclose(fp);return retcode;}
	/* FIXME et si on ne supporte pas le resuming? */
	if(retcode=wait4(infos->sockfd,350)) {fclose(fp);return retcode;}

	if(retcode=ecrit(infos->sockfd,"REST 0\r\n",restartPos)) {fclose(fp);return retcode;}
	if(retcode=wait4(infos->sockfd,350)) {fclose(fp);return retcode;}

	if(restartPos>0){
		if(retcode=ecrit(infos->sockfd,"REST %i\r\n",restartPos)) {fclose(fp);return retcode;}
		if(retcode=wait4(infos->sockfd,350)) {fclose(fp);return retcode;}
	}

	if(retcode=ecrit(infos->sockfd,"RETR %s\r\n",infos->filename)) {fclose(fp);return retcode;}
	if(retcode=wait4(infos->sockfd,150)) {fclose(fp);return retcode;}

	sizeLeft=infos->size-restartPos;

	for(;;){
		sizeToRead=sizeLeft;
		if(sizeToRead>BUFFER_DOWNLOAD_SIZE) sizeToRead=BUFFER_DOWNLOAD_SIZE;
		printf("%i size restant: %i %i\n",pthread_self(),sizeLeft,sizeToRead);

		retcode=read(infos->sockfd_data,buffer,sizeToRead);
		fwrite(buffer,retcode,1,fp); // FIXME ! : traitement d'erreur: plus de place, ...
		sizeLeft-=retcode;
		if(retcode<1 || sizeLeft==0) break;
	}

	if(retcode<1) {fclose(fp);return retcode;}
	if(retcode=wait4(infos->sockfd,226)) {fclose(fp);return retcode;}



	if(fp!=NULL) fclose(fp);


}



int get_line_once(int sockfd, char *buffer, char *line, int *offset){
	char *occ;
	char *alloc;
	char *ptr;
	int resultat;
	int size;
	int decalage;
	char buffer2[BUFFER_SIZE+1];


	fd_set testfds;
	struct timeval timeout;

	timeout.tv_sec=20;
	timeout.tv_usec=0;

	FD_ZERO(&testfds);
	FD_SET(sockfd,&testfds);

	ptr=buffer+*offset;

	occ=index(ptr,'\n');
	if(occ==NULL){
		char *ptr2;
		size=BUFFER_SIZE-*offset-strlen(ptr)-1;

		ptr2=ptr+strlen(ptr);
		*ptr2='\0';
		do{
			if(size==0){
				int decalage=ptr-buffer;
				int len=strlen(ptr);
				memmove(buffer,ptr,len);
				buffer[len]='\0';
				*offset-=decalage;
				size=BUFFER_SIZE-len-1;
				ptr=buffer+*offset;
				ptr2=ptr+strlen(ptr);
			}

			resultat=select(FD_SETSIZE,&testfds, (fd_set*)NULL, (fd_set*)NULL, &timeout);
			if(resultat==0){
				printf("timeout\n");
				return ERR_SOCKET_TIMEOUT;
			}

			resultat=read(sockfd,ptr2,size);

			if(resultat==0) return EOF;
			if(resultat<1) return ERR_SOCKET_WRITE_ERROR;

			*(ptr2+resultat)='\0';

			ptr2+=resultat;
			size-=resultat;
		} while( (occ=index(ptr,'\n'))==NULL );
	}
	size=occ-ptr;

	if(size>BUFFER_SIZE_LINE) size=BUFFER_SIZE_LINE;
	strncpy(line,ptr,size);
	line[size-1]='\0'; /* vire le \r\n */
	*offset+=(size+1);

	return 0;
}












/*
   int lit(int sockfd,char *buffer){
   int resultat;
   int i=0;
   char *buffer_ptr=buffer;

   fd_set testfds;
   struct timeval timeout;

   timeout.tv_sec=20;
   timeout.tv_usec=0;

   FD_ZERO(&testfds);
   FD_SET(sockfd,&testfds);

   resultat=select(FD_SETSIZE,&testfds, (fd_set*)NULL, (fd_set*)NULL, &timeout);
   if(resultat==0){
//buffer_ptr[0]='\0';
printf("timeout\n");
return ERR_SOCKET_TIMEOUT;
}
else if(resultat==-1){
perror("select");
//close(sockfd);
return ERR_SOCKET_SELECT;
}


resultat=read(sockfd,buffer_ptr,BUFFER_SIZE);
buffer_ptr[resultat]='\0';

return 0;
}
*/

int wait4(int sockfd, int code){
	int resultat=ERR_SOCKET_WRITE_ERROR;
	//char *line;
	char line[BUFFER_SIZE_LINE];
	char buffer[BUFFER_SIZE];
	char reply[4];
	int offset;

	offset=0;
	buffer[0]='\0';

	for(;;){
		if(resultat=get_line_once(sockfd, buffer, line, &offset)) return resultat;	
		printf("%i Recu: %s\n",pthread_self(),line);

		if(line[3]!='-'){
			strncpy(reply,line,3);
			reply[3]='\0';
			resultat=atoi(reply);

			//free(line);
			break;
		}
		//free(line);
	}

	if(resultat==code) return 0;
	return resultat;
}







int ecrit(int sockfd,const char *fmt,...){
	char buffer[8192]; /* FIXME: taille du buffer d'envoi */

	va_list args;
	//int i;

	va_start(args, fmt);
	vsnprintf(buffer,sizeof(buffer)-1,fmt,args);
	va_end(args);
	//return i;


	printf("%i Envoi  : %s",pthread_self(),buffer);

	if( write(sockfd,buffer,strlen(buffer))==-1 ){
		//close(sockfd);
		return ERR_SOCKET_WRITE_ERROR;
	}
	return 0;

}






int getip(char* hote, char*buffer){
	char **addrs;
	struct hostent *infohote;

	infohote=gethostbyname(hote);
	if(!infohote){
		printf("Erreur: %s: unknown host\n",hote);
		return ERR_CANT_RESOLVE;
	}
	if(infohote->h_addrtype!=AF_INET){
		printf("Erreur: %s: n'est pas un hote ip!\n",hote);
		return ERR_CANT_RESOLVE;
	}
	addrs=infohote->h_addr_list;
	//printf("ip: %s\n",inet_ntoa(* (struct in_addr *) *addrs));

	strcpy(buffer,inet_ntoa(* (struct in_addr *) *addrs) );
	return 0;
}




	int getinfos_folder(_infos *infos){
		char buffer[BUFFER_SIZE];
		int retcode=0;
		char line[BUFFER_SIZE_LINE];
		int offset;
		char pdir[strlen(infos->path)+1];
		char filename[strlen(infos->path)+1];




		int i;
		_infos *newList;
		_infos *newFolder;
		char *ptr;




		retcode=send_cwd(infos);
		if(retcode==0){
			if( retcode=send_pasv(infos) ) return retcode;
			if( retcode=ecrit(infos->sockfd,"LIST -a -l\r\n") ) return retcode;
			if( retcode=wait4(infos->sockfd,150) ) return retcode;

		}
		else if(retcode==ERR_FTP_SERVER_PERMISSION_DENIED){}
		else  return retcode;




			newList=NULL;
			newFolder=NULL;

			offset=0;
			buffer[0]='\0';

			while( (retcode=get_line_once(infos->sockfd_data,buffer,line,&offset))==0){
				ptr=line;
				for(i=0;i<8;i++) ptr=nextchar(nextspace(ptr));
				if(strcmp(ptr,".")==0 || strcmp(ptr,"..")==0){
					//free(line);
					continue;
				}


				if( (newList=liste_clone_after(newList))==NULL ){
					return ERR_MALLOC_ERROR;
				}

				if(newFolder==NULL){
					newFolder=newList;  // S'il s'agit de la premiere entree du repertoire
					memmove(newFolder, infos, sizeof(_infos)); // On recopie les infos contenues dans la structure courante
					defaultvalues(newFolder);
				}
				///////////////////////////////////
				strcpy(newList->path,infos->path);

				/* FIXME! pas propre */
				if(strcmp(newList->path,"/")!=0) strcat(newList->path,"/");
				strcat(newList->path,ptr);

				//newList->sockfd=infos->sockfd;
				//newList->sockfd_data=infos->sockfd_data;
				newList->suiv=NULL;

				parse_line(newList,line);

			}
			affiche_infos(newFolder);
			if( (newFolder==NULL) || (retcode!=0 && retcode!=EOF) ){ // Il y a eu une erreur lors de la lecture du repertoire
				printf("timeout recupere dans getinfos\n");         // ou alors le dossier etait vide

				liste_del_all(newFolder);
				// FIXME! pas propre!
				liste_clone_after(infos); // On replique le dossier qui a cause l'erreur, la main va effacer la premiere occurence
				return retcode;
			}

			if(newFolder!=NULL){ // si le dossier parcouru n'etait pas vide...
				(liste_last(newFolder))->suiv=infos->suiv; // On l'insere dans la liste
				infos->suiv=newFolder;
			}


			if( retcode=wait4(infos->sockfd,226) ) return retcode;
			buffer[0]='\0';
		

			CloseDataSocket(infos);

			return 0;
		}











	int getinfos_bak(_infos *infos){
		//char *buffer=infos->buffer;
		char buffer[BUFFER_SIZE];
		int retcode=0;
		//int sockfd=infos->sockfd;
		//char *line;
		char line[BUFFER_SIZE_LINE];
		int offset;
		char pdir[strlen(infos->path)+1];
		char filename[strlen(infos->path)+1];



		if(infos->isafolder=='?'){

			char *index;
			char *tmp=strdup(infos->path);
			strcpy(pdir,infos->path);
			index=rindex(pdir,'/');

			*index='\0';
			strcpy(filename,tmp+strlen(pdir)+1);
			free(tmp);
			strcpy(infos->path,pdir);

			//if( retcode=ecrit(infos->sockfd,"CWD %s\r\n",pdir) ) return retcode;

		}
		else if(infos->isafolder=='Y'){

			//if( retcode=ecrit(infos->sockfd,"CWD %s\r\n",infos->path) ) return retcode;

		}

		retcode=send_cwd(infos);
		if(retcode==0){
			if( retcode=send_pasv(infos) ) return retcode;
			if( retcode=ecrit(infos->sockfd,"LIST -a -l\r\n") ) return retcode;
			if( retcode=wait4(infos->sockfd,150) ) return retcode;

		}
		else if(retcode==ERR_FTP_SERVER_PERMISSION_DENIED){}
		else  return retcode;

		if(infos->isafolder=='?'){
			offset=0;
			buffer[0]='\0';

			while( (retcode=get_line_once(infos->sockfd_data,buffer,line,&offset))==0){

				int llen=strlen(line);
				int flen=strlen(filename);
				int diff=llen-flen;
				if(diff>0 && strncmp(filename,line+diff,flen)==0){
					parse_line(infos,line);
				}
				//free(line);

			}

			//if(retcode) return retcode;
			if(infos->isafolder=='?') return ERR_FILE_NOT_FOUND;


			if( retcode=wait4(infos->sockfd,226) ) return retcode;
		}
		else if(infos->isafolder=='Y'){

			int i;
			_infos *newList;
			_infos *newFolder;
			char *ptr;

			newList=NULL;
			newFolder=NULL;

			offset=0;
			buffer[0]='\0';

			while( (retcode=get_line_once(infos->sockfd_data,buffer,line,&offset))==0){
				ptr=line;
				for(i=0;i<8;i++) ptr=nextchar(nextspace(ptr));
				if(strcmp(ptr,".")==0 || strcmp(ptr,"..")==0){
					//free(line);
					continue;
				}


				//if( (newList=liste_clone_after(liste_last(newFolder)))==NULL ){
				if( (newList=liste_clone_after(newList))==NULL ){
					return ERR_MALLOC_ERROR;
				}

				if(newFolder==NULL){
					newFolder=newList;  // S'il s'agit de la premiere entree du repertoire
					memmove(newFolder, infos, sizeof(_infos)); // On recopie les infos contenues dans la structure courante
					defaultvalues(newFolder);
				}
				///////////////////////////////////
				strcpy(newList->path,infos->path);

				/* FIXME! pas propre */
				if(strcmp(newList->path,"/")!=0) strcat(newList->path,"/");
				strcat(newList->path,ptr);

				//newList->sockfd=infos->sockfd;
				//newList->sockfd_data=infos->sockfd_data;
				newList->suiv=NULL;

				parse_line(newList,line);

			}
			affiche_infos(newFolder);
			if( (newFolder==NULL) || (retcode!=0 && retcode!=EOF) ){ // Il y a eu une erreur lors de la lecture du repertoire
				printf("timeout recupere dans getinfos\n");         // ou alors le dossier etait vide

				liste_del_all(newFolder);
				// FIXME! pas propre!
				liste_clone_after(infos); // On replique le dossier qui a cause l'erreur, la main va effacer la premiere occurence
				return retcode;
			}

			if(newFolder!=NULL){ // si le dossier parcouru n'etait pas vide...
				(liste_last(newFolder))->suiv=infos->suiv; // On l'insere dans la liste
				infos->suiv=newFolder;
			}


			if( retcode=wait4(infos->sockfd,226) ) return retcode;
			buffer[0]='\0';
			}

			CloseDataSocket(infos);

			return 0;
		}







		int getinfos_unknown(_infos *infos){
			char buffer[BUFFER_SIZE];
			int retcode=0;
			char line[BUFFER_SIZE_LINE];
			int offset;



			int llen;
			int flen;
			int diff;

			retcode=send_cwd(infos);
			if(retcode==0){
				if( retcode=send_pasv(infos) ) return retcode;
				if( retcode=ecrit(infos->sockfd,"LIST -a -l\r\n") ) return retcode;
				if( retcode=wait4(infos->sockfd,150) ) return retcode;

			}
			else if(retcode==ERR_FTP_SERVER_PERMISSION_DENIED){}
			else return retcode;

			infos->isafolder='?';

			offset=0;
			buffer[0]='\0';

			while( (retcode=get_line_once(infos->sockfd_data,buffer,line,&offset))==0){
				llen=strlen(line);
				flen=strlen(infos->filename);
				diff=llen-flen;

				if(diff>0 && infos->isafolder=='?' && strncmp(infos->filename,line+diff,flen)==0){
				    parse_line(infos,line);
				}
			}


			if(infos->isafolder=='?') return ERR_FILE_NOT_FOUND;

			if( retcode=wait4(infos->sockfd,226) ) return retcode;

			CloseDataSocket(infos);

			return 0;
		}





		char *nextspace(char *string){
			while(*string!='\0' && *string!=' ') string++;
			return string;
		}
		char *nextchar(char *string){
			while(*string!='\0' && *string==' ') string++;
			return string;
		}

		char *nextspace_r(char *string, char *ptr){
			while(ptr!=string && *ptr!=' ') ptr--;
			return ptr;
		}

		char *nextchar_r(char *string, char *ptr){
			while(ptr!=string && *ptr==' ') ptr--;
			return ptr;
		}

		void parse_line(_infos *infos,char *line){
			int i;
			int size;
			char *ptr=line;
			for(i=0;i<4;i++) ptr=nextchar(nextspace(ptr));

			if(line[0]=='d'){ /* C'est un dossier */
				infos->isafolder='Y';
				infos->filename[0]='\0';
				infos->size=0;
			}
			else if(line[0]=='-'){ /* C'est un fichier */
				//char *filename;
				//if(strlen(infos->path)==0) strcpy(infos->path,"/");
				//filename=rindex(infos->path,'/')+1;
				infos->isafolder='N';
				infos->size=atoi(ptr);
				//strcpy(infos->filename,filename);
				//infos->path[strlen(infos->path)-strlen(infos->filename)]='\0';
			}
			else{
				infos->size=0;
				infos->isafolder='E';
			}
		}
