typedef struct{
	char hostname[256];
	char ip[16];
	char user[256];
	char pass[256];
	unsigned short int proto;
	unsigned short int ftp_mode;
	unsigned short int port;
} _hostinfos;


typedef struct _infostmp {
	//char hostname[256];
	//char ip[16];
	//char user[256];
	//char pass[256];
	//unsigned short int proto;
	//unsigned short int ftp_mode;
	//unsigned short int port;

	_hostinfos* hostinfos;

	//char url[8192];      		/* FIXME! */
	char path[PATH_MAX];	        /* FIXME! */
	char filename[FILENAME_MAX];    /* FIXME! */
	unsigned short int dataport;

	char isafolder;

	unsigned long int size;
	unsigned long int completedSize;
	char localFilePath[PATH_MAX];
	char localFileName[FILENAME_MAX];

	int sockfd;
	int sockfd_data;

	pthread_t threadID;

	struct _infostmp *suiv;
} _infos;

_infos *liste_last(_infos *);
_infos *liste_del(_infos *);
_infos *liste_deb=NULL;


void defaultvalues(_infos *infos){
	infos->sockfd=-1;
	infos->sockfd_data=-1;
	infos->completedSize=0;
	strcpy(infos->localFilePath,"");
	strcpy(infos->localFileName,"");
	infos->completedSize=0;
	infos->threadID=0;
}





_infos *liste_clone_after(_infos *infos){
	_infos *ptr;
	_infos *suiv;
	ptr=(_infos *)malloc(sizeof(_infos));
	if(ptr==NULL) return NULL;
	if(infos!=NULL){
		memcpy(ptr,infos,sizeof(_infos));
		ptr->suiv=infos->suiv;
		infos->suiv=ptr;
	}
	else{ 		// si infos==NULL (c'est la premiere liste qu'on cree)
		ptr->suiv=NULL;
	}

	defaultvalues(ptr);
	return ptr;
}


_infos *liste_suiv(_infos *ptr){
	if(ptr==NULL) return NULL;
	return ptr->suiv;
}

_infos *liste_last(_infos *ptr){
	//_infos *ptr=liste_deb;
	_infos *ptr_last=ptr;
	while(ptr!=NULL){
		ptr_last=ptr;
		ptr=ptr->suiv;
	}
	return ptr_last;
}

_infos *liste_prec(_infos *infos){
	_infos *ptr=liste_deb;
	_infos *ptr_last=liste_deb;

	while(ptr!=NULL){
		if(ptr==infos) return ptr_last;
		ptr_last=ptr;
		ptr=ptr->suiv;
	}
	return NULL;
}


void liste_del_all(_infos *deb){
	_infos *ptr;
	_infos *ptr_bak;
	_infos *newdeb;

	for(;;){
		ptr=deb;
		ptr_bak=deb;
		if(ptr==NULL) return;

		deb=liste_del(liste_last(deb));

	}

	if(deb==liste_deb) liste_deb=NULL;

	return;

}



_infos *liste_del(_infos *infos){
	_infos *ptr_prec;
	//_infos *newDeb=infos;
	if(infos==NULL) return NULL;



	if(infos==liste_deb){
		_infos *new_liste_deb=infos->suiv;
		free(infos);
		return new_liste_deb;
	}   


	ptr_prec=liste_prec(infos);
	ptr_prec->suiv=infos->suiv;
	free(infos);

	return liste_deb;
}

int liste_count(_infos *deb){
	int i=0;
	_infos *ptr=deb;
	//_infos *suiv;
	while(ptr!=NULL){
		i++;
		ptr=ptr->suiv;
	}
	return i;
}

int affiche_infos(_infos *deb){
	int i=0;
	_infos *ptr=deb;
	//_infos *suiv;
	while(ptr!=NULL){
		i++;
		printf("%c ",ptr->isafolder);
		printf("path: %s - %s, taille %i - sock: %i %i\n",ptr->path,ptr->filename,ptr->size,ptr->sockfd,ptr->sockfd_data);
		ptr=ptr->suiv;
	}

	printf("\n");
	return i;
}

